
#ifndef __SCREEN_H__
#define __SCREEN_H__

#ifdef __cplusplus
extern "C" {
#endif

//---------------------------------------------------------------------------
#define SCREEN_MSG_SX			0
#define SCREEN_MSG_SY			115
#define SCREEN_MSG_LINE			4
#define SCREEN_MSG_LEN			(48+1)

#define MENU_STR_LEN			(48+1)
#define MENU_MAX_ITEM			4

#define CURSOR_TILENO			514
//---------------------------------------------------------------------------

//j[
typedef struct {
	u8  str[MENU_STR_LEN];
	u16 ans;
	u16 len;
} ST_SCREEN_MENU;


typedef struct {
	//XN[obt@
	u16  buf[SCREEN_CY][SCREEN_CX]   ALIGN(4);
	u16  chr[SCREEN_CY][SCREEN_CX/2] ALIGN(4);
	//bZ[Wobt@
	u8   msg[SCREEN_MSG_LINE][SCREEN_MSG_LEN];
	u8   msgLine;
	//ptO
	bool flagUpdate;
	bool flagWait;
	bool flagMenu;
	//CG\ptO
	bool flagBack;
	bool flagCenter;
	bool flagLeft;
	bool flagRight;
	bool flagMsg;
	//CG\pItZbg
	u8*  fpBack;
	u8*  fpCenter;
	u8*  fpLeft;
	u8*  fpRight;
	//Ip
	ST_SCREEN_MENU menu[MENU_MAX_ITEM];
	u16            menuCnt;
	u16            menuAdr;
	//_~[
	u32  dummyU32 ALIGN(4);
} ST_SCREEN;


typedef struct {
	u8   x;
	u8   y;
	u8   cx;
	u8   cy;
	s16  minX;								//ړ
	s16  maxX;
	s16  minY;
	s16  maxY;
	u16  sprNo;
	u16  sprTile;
	u16  sprSize;
	u16  sprForm;
	u8   selCnt;							//I
} ST_CURSOR;


//---------------------------------------------------------------------------
EWRAM_CODE void ScreenInit();
EWRAM_CODE void ScreenInitMsg();


EWRAM_CODE void ScreenDraw();
EWRAM_CODE void ScreenWait();
EWRAM_CODE void ScreenMenu();


EWRAM_CODE void ScreenCalc();
EWRAM_CODE void ScreenCalcMsg(u8* msg);
EWRAM_CODE void ScreenCalcLoad(u8* str, u16 pos);
EWRAM_CODE void ScreenCalcClear(u16 pos);
EWRAM_CODE void ScreenCalcMenuClear();
EWRAM_CODE void ScreenCalcMenuSetItem(u8* str, u16 ans);
EWRAM_CODE void ScreenCalcMenu(u16 adr);


EWRAM_CODE void ScreenBufCls();
EWRAM_CODE void ScreenBufDrawMsg();
EWRAM_CODE void ScreenBufCopyBack();
EWRAM_CODE void ScreenBufCopyRight();
EWRAM_CODE void ScreenBufCopyLeft();
EWRAM_CODE void ScreenBufCopyCenter();
EWRAM_CODE void ScreenBufFillCopy(u16 sx, u16 sy, u16 cx, u16 cy, u16* img);
EWRAM_CODE void ScreenBufDrawMsgWindow();
EWRAM_CODE void ScreenVRAMCopyBuf();


//----
EWRAM_CODE void CursorInit();
EWRAM_CODE void CursorReset();
EWRAM_CODE void CursorDraw();
EWRAM_CODE void CursorMoveIn();
EWRAM_CODE void CursorMoveOut();


#ifdef __cplusplus
}
#endif
#endif

